const Ajv = require('ajv')
const ajv = new Ajv({allErrors: true, useDefaults: true})

class JsonValidator {
  constructor (schemas) {
    this.schemas = schemas
    this.error = false
    this.value = undefined
  }

  getSchema (name) {
    if (this.schemas.hasOwnProperty(name)) {
      return this.schemas[name]
    } else {
      return false
    }
  }

  validate (obj, schema) {
    this.error = false
    this.value = undefined
    let objSchema

    switch (typeof schema) {
      case 'string':
        objSchema = this.getSchema(schema)
        break
      case 'object':
        objSchema = schema
        break
      default:
        this.error = 'Invalid input schema'
        return this
    }

    if (this.isSuccess()) {
      const validate = ajv.compile(objSchema)
      const valid = validate(obj)
      if (valid) {
        this.error = false
        this.value = obj
        return this
      } else {
        this.error = ajv.errorsText(validate.errors)
        this.value = undefined
        return this
      }
    }
  }

  isSuccess () {
    return !this.error
  }
}

const schemas = {
}

module.exports = () => {
  return new JsonValidator(schemas)
}
